# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class VmGpuInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'gpu_devices': 'list[VmGpuDetail]',
        'name': 'str',
        'local_id': 'str',
        'id': 'str'
    }

    attribute_map = {
        'gpu_devices': 'gpu_devices',
        'name': 'name',
        'local_id': 'local_id',
        'id': 'id'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """VmGpuInfo - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._gpu_devices = None
        self._name = None
        self._local_id = None
        self._id = None
        self.discriminator = None

        if "gpu_devices" in kwargs:
            self.gpu_devices = kwargs["gpu_devices"]
        if "name" in kwargs:
            self.name = kwargs["name"]
        if "local_id" in kwargs:
            self.local_id = kwargs["local_id"]
        if "id" in kwargs:
            self.id = kwargs["id"]

    @property
    def gpu_devices(self):
        """Gets the gpu_devices of this VmGpuInfo.  # noqa: E501


        :return: The gpu_devices of this VmGpuInfo.  # noqa: E501
        :rtype: list[VmGpuDetail]
        """
        return self._gpu_devices

    @gpu_devices.setter
    def gpu_devices(self, gpu_devices):
        """Sets the gpu_devices of this VmGpuInfo.


        :param gpu_devices: The gpu_devices of this VmGpuInfo.  # noqa: E501
        :type gpu_devices: list[VmGpuDetail]
        """
        if self.local_vars_configuration.client_side_validation and gpu_devices is None:  # noqa: E501
            raise ValueError("Invalid value for `gpu_devices`, must not be `None`")  # noqa: E501

        self._gpu_devices = gpu_devices

    @property
    def name(self):
        """Gets the name of this VmGpuInfo.  # noqa: E501


        :return: The name of this VmGpuInfo.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VmGpuInfo.


        :param name: The name of this VmGpuInfo.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def local_id(self):
        """Gets the local_id of this VmGpuInfo.  # noqa: E501


        :return: The local_id of this VmGpuInfo.  # noqa: E501
        :rtype: str
        """
        return self._local_id

    @local_id.setter
    def local_id(self, local_id):
        """Sets the local_id of this VmGpuInfo.


        :param local_id: The local_id of this VmGpuInfo.  # noqa: E501
        :type local_id: str
        """
        if self.local_vars_configuration.client_side_validation and local_id is None:  # noqa: E501
            raise ValueError("Invalid value for `local_id`, must not be `None`")  # noqa: E501

        self._local_id = local_id

    @property
    def id(self):
        """Gets the id of this VmGpuInfo.  # noqa: E501


        :return: The id of this VmGpuInfo.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VmGpuInfo.


        :param id: The id of this VmGpuInfo.  # noqa: E501
        :type id: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VmGpuInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VmGpuInfo):
            return True

        return self.to_dict() != other.to_dict()
