# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class VmImportParams(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'max_bandwidth_policy': 'VmDiskIoRestrictType',
        'max_bandwidth_unit': 'BPSUnit',
        'max_bandwidth': 'int',
        'max_iops_policy': 'VmDiskIoRestrictType',
        'max_iops': 'int',
        'io_policy': 'VmDiskIoPolicy',
        'vcpu': 'int',
        'status': 'VmStatus',
        'ha': 'bool',
        'vm_nics': 'list[VmImportNicParams]',
        'disk_operate': 'OvfDiskOperate',
        'memory_unit': 'ByteUnit',
        'memory': 'int',
        'cpu_cores': 'int',
        'cpu_sockets': 'int',
        'guest_os_type': 'VmGuestsOperationSystem',
        'folder_id': 'str',
        'description': 'str',
        'name': 'str',
        'host_id': 'str',
        'cluster_id': 'str',
        'upload_tasks': 'list[str]',
        'owner_id': 'str',
        'parsed_ovf': 'ParsedOVF'
    }

    attribute_map = {
        'max_bandwidth_policy': 'max_bandwidth_policy',
        'max_bandwidth_unit': 'max_bandwidth_unit',
        'max_bandwidth': 'max_bandwidth',
        'max_iops_policy': 'max_iops_policy',
        'max_iops': 'max_iops',
        'io_policy': 'io_policy',
        'vcpu': 'vcpu',
        'status': 'status',
        'ha': 'ha',
        'vm_nics': 'vm_nics',
        'disk_operate': 'disk_operate',
        'memory_unit': 'memory_unit',
        'memory': 'memory',
        'cpu_cores': 'cpu_cores',
        'cpu_sockets': 'cpu_sockets',
        'guest_os_type': 'guest_os_type',
        'folder_id': 'folder_id',
        'description': 'description',
        'name': 'name',
        'host_id': 'host_id',
        'cluster_id': 'cluster_id',
        'upload_tasks': 'upload_tasks',
        'owner_id': 'owner_id',
        'parsed_ovf': 'parsed_ovf'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """VmImportParams - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._max_bandwidth_policy = None
        self._max_bandwidth_unit = None
        self._max_bandwidth = None
        self._max_iops_policy = None
        self._max_iops = None
        self._io_policy = None
        self._vcpu = None
        self._status = None
        self._ha = None
        self._vm_nics = None
        self._disk_operate = None
        self._memory_unit = None
        self._memory = None
        self._cpu_cores = None
        self._cpu_sockets = None
        self._guest_os_type = None
        self._folder_id = None
        self._description = None
        self._name = None
        self._host_id = None
        self._cluster_id = None
        self._upload_tasks = None
        self._owner_id = None
        self._parsed_ovf = None
        self.discriminator = None

        if "max_bandwidth_policy" in kwargs:
            self.max_bandwidth_policy = kwargs["max_bandwidth_policy"]
        if "max_bandwidth_unit" in kwargs:
            self.max_bandwidth_unit = kwargs["max_bandwidth_unit"]
        if "max_bandwidth" in kwargs:
            self.max_bandwidth = kwargs["max_bandwidth"]
        if "max_iops_policy" in kwargs:
            self.max_iops_policy = kwargs["max_iops_policy"]
        if "max_iops" in kwargs:
            self.max_iops = kwargs["max_iops"]
        if "io_policy" in kwargs:
            self.io_policy = kwargs["io_policy"]
        if "vcpu" in kwargs:
            self.vcpu = kwargs["vcpu"]
        if "status" in kwargs:
            self.status = kwargs["status"]
        if "ha" in kwargs:
            self.ha = kwargs["ha"]
        if "vm_nics" in kwargs:
            self.vm_nics = kwargs["vm_nics"]
        if "disk_operate" in kwargs:
            self.disk_operate = kwargs["disk_operate"]
        if "memory_unit" in kwargs:
            self.memory_unit = kwargs["memory_unit"]
        if "memory" in kwargs:
            self.memory = kwargs["memory"]
        if "cpu_cores" in kwargs:
            self.cpu_cores = kwargs["cpu_cores"]
        if "cpu_sockets" in kwargs:
            self.cpu_sockets = kwargs["cpu_sockets"]
        if "guest_os_type" in kwargs:
            self.guest_os_type = kwargs["guest_os_type"]
        if "folder_id" in kwargs:
            self.folder_id = kwargs["folder_id"]
        if "description" in kwargs:
            self.description = kwargs["description"]
        if "name" in kwargs:
            self.name = kwargs["name"]
        if "host_id" in kwargs:
            self.host_id = kwargs["host_id"]
        if "cluster_id" in kwargs:
            self.cluster_id = kwargs["cluster_id"]
        if "upload_tasks" in kwargs:
            self.upload_tasks = kwargs["upload_tasks"]
        if "owner_id" in kwargs:
            self.owner_id = kwargs["owner_id"]
        if "parsed_ovf" in kwargs:
            self.parsed_ovf = kwargs["parsed_ovf"]

    @property
    def max_bandwidth_policy(self):
        """Gets the max_bandwidth_policy of this VmImportParams.  # noqa: E501


        :return: The max_bandwidth_policy of this VmImportParams.  # noqa: E501
        :rtype: VmDiskIoRestrictType
        """
        return self._max_bandwidth_policy

    @max_bandwidth_policy.setter
    def max_bandwidth_policy(self, max_bandwidth_policy):
        """Sets the max_bandwidth_policy of this VmImportParams.


        :param max_bandwidth_policy: The max_bandwidth_policy of this VmImportParams.  # noqa: E501
        :type max_bandwidth_policy: VmDiskIoRestrictType
        """

        self._max_bandwidth_policy = max_bandwidth_policy

    @property
    def max_bandwidth_unit(self):
        """Gets the max_bandwidth_unit of this VmImportParams.  # noqa: E501


        :return: The max_bandwidth_unit of this VmImportParams.  # noqa: E501
        :rtype: BPSUnit
        """
        return self._max_bandwidth_unit

    @max_bandwidth_unit.setter
    def max_bandwidth_unit(self, max_bandwidth_unit):
        """Sets the max_bandwidth_unit of this VmImportParams.


        :param max_bandwidth_unit: The max_bandwidth_unit of this VmImportParams.  # noqa: E501
        :type max_bandwidth_unit: BPSUnit
        """

        self._max_bandwidth_unit = max_bandwidth_unit

    @property
    def max_bandwidth(self):
        """Gets the max_bandwidth of this VmImportParams.  # noqa: E501


        :return: The max_bandwidth of this VmImportParams.  # noqa: E501
        :rtype: int
        """
        return self._max_bandwidth

    @max_bandwidth.setter
    def max_bandwidth(self, max_bandwidth):
        """Sets the max_bandwidth of this VmImportParams.


        :param max_bandwidth: The max_bandwidth of this VmImportParams.  # noqa: E501
        :type max_bandwidth: int
        """

        self._max_bandwidth = max_bandwidth

    @property
    def max_iops_policy(self):
        """Gets the max_iops_policy of this VmImportParams.  # noqa: E501


        :return: The max_iops_policy of this VmImportParams.  # noqa: E501
        :rtype: VmDiskIoRestrictType
        """
        return self._max_iops_policy

    @max_iops_policy.setter
    def max_iops_policy(self, max_iops_policy):
        """Sets the max_iops_policy of this VmImportParams.


        :param max_iops_policy: The max_iops_policy of this VmImportParams.  # noqa: E501
        :type max_iops_policy: VmDiskIoRestrictType
        """

        self._max_iops_policy = max_iops_policy

    @property
    def max_iops(self):
        """Gets the max_iops of this VmImportParams.  # noqa: E501


        :return: The max_iops of this VmImportParams.  # noqa: E501
        :rtype: int
        """
        return self._max_iops

    @max_iops.setter
    def max_iops(self, max_iops):
        """Sets the max_iops of this VmImportParams.


        :param max_iops: The max_iops of this VmImportParams.  # noqa: E501
        :type max_iops: int
        """

        self._max_iops = max_iops

    @property
    def io_policy(self):
        """Gets the io_policy of this VmImportParams.  # noqa: E501


        :return: The io_policy of this VmImportParams.  # noqa: E501
        :rtype: VmDiskIoPolicy
        """
        return self._io_policy

    @io_policy.setter
    def io_policy(self, io_policy):
        """Sets the io_policy of this VmImportParams.


        :param io_policy: The io_policy of this VmImportParams.  # noqa: E501
        :type io_policy: VmDiskIoPolicy
        """

        self._io_policy = io_policy

    @property
    def vcpu(self):
        """Gets the vcpu of this VmImportParams.  # noqa: E501


        :return: The vcpu of this VmImportParams.  # noqa: E501
        :rtype: int
        """
        return self._vcpu

    @vcpu.setter
    def vcpu(self, vcpu):
        """Sets the vcpu of this VmImportParams.


        :param vcpu: The vcpu of this VmImportParams.  # noqa: E501
        :type vcpu: int
        """

        self._vcpu = vcpu

    @property
    def status(self):
        """Gets the status of this VmImportParams.  # noqa: E501


        :return: The status of this VmImportParams.  # noqa: E501
        :rtype: VmStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this VmImportParams.


        :param status: The status of this VmImportParams.  # noqa: E501
        :type status: VmStatus
        """

        self._status = status

    @property
    def ha(self):
        """Gets the ha of this VmImportParams.  # noqa: E501


        :return: The ha of this VmImportParams.  # noqa: E501
        :rtype: bool
        """
        return self._ha

    @ha.setter
    def ha(self, ha):
        """Sets the ha of this VmImportParams.


        :param ha: The ha of this VmImportParams.  # noqa: E501
        :type ha: bool
        """

        self._ha = ha

    @property
    def vm_nics(self):
        """Gets the vm_nics of this VmImportParams.  # noqa: E501


        :return: The vm_nics of this VmImportParams.  # noqa: E501
        :rtype: list[VmImportNicParams]
        """
        return self._vm_nics

    @vm_nics.setter
    def vm_nics(self, vm_nics):
        """Sets the vm_nics of this VmImportParams.


        :param vm_nics: The vm_nics of this VmImportParams.  # noqa: E501
        :type vm_nics: list[VmImportNicParams]
        """

        self._vm_nics = vm_nics

    @property
    def disk_operate(self):
        """Gets the disk_operate of this VmImportParams.  # noqa: E501


        :return: The disk_operate of this VmImportParams.  # noqa: E501
        :rtype: OvfDiskOperate
        """
        return self._disk_operate

    @disk_operate.setter
    def disk_operate(self, disk_operate):
        """Sets the disk_operate of this VmImportParams.


        :param disk_operate: The disk_operate of this VmImportParams.  # noqa: E501
        :type disk_operate: OvfDiskOperate
        """

        self._disk_operate = disk_operate

    @property
    def memory_unit(self):
        """Gets the memory_unit of this VmImportParams.  # noqa: E501


        :return: The memory_unit of this VmImportParams.  # noqa: E501
        :rtype: ByteUnit
        """
        return self._memory_unit

    @memory_unit.setter
    def memory_unit(self, memory_unit):
        """Sets the memory_unit of this VmImportParams.


        :param memory_unit: The memory_unit of this VmImportParams.  # noqa: E501
        :type memory_unit: ByteUnit
        """

        self._memory_unit = memory_unit

    @property
    def memory(self):
        """Gets the memory of this VmImportParams.  # noqa: E501


        :return: The memory of this VmImportParams.  # noqa: E501
        :rtype: int
        """
        return self._memory

    @memory.setter
    def memory(self, memory):
        """Sets the memory of this VmImportParams.


        :param memory: The memory of this VmImportParams.  # noqa: E501
        :type memory: int
        """

        self._memory = memory

    @property
    def cpu_cores(self):
        """Gets the cpu_cores of this VmImportParams.  # noqa: E501


        :return: The cpu_cores of this VmImportParams.  # noqa: E501
        :rtype: int
        """
        return self._cpu_cores

    @cpu_cores.setter
    def cpu_cores(self, cpu_cores):
        """Sets the cpu_cores of this VmImportParams.


        :param cpu_cores: The cpu_cores of this VmImportParams.  # noqa: E501
        :type cpu_cores: int
        """

        self._cpu_cores = cpu_cores

    @property
    def cpu_sockets(self):
        """Gets the cpu_sockets of this VmImportParams.  # noqa: E501


        :return: The cpu_sockets of this VmImportParams.  # noqa: E501
        :rtype: int
        """
        return self._cpu_sockets

    @cpu_sockets.setter
    def cpu_sockets(self, cpu_sockets):
        """Sets the cpu_sockets of this VmImportParams.


        :param cpu_sockets: The cpu_sockets of this VmImportParams.  # noqa: E501
        :type cpu_sockets: int
        """

        self._cpu_sockets = cpu_sockets

    @property
    def guest_os_type(self):
        """Gets the guest_os_type of this VmImportParams.  # noqa: E501


        :return: The guest_os_type of this VmImportParams.  # noqa: E501
        :rtype: VmGuestsOperationSystem
        """
        return self._guest_os_type

    @guest_os_type.setter
    def guest_os_type(self, guest_os_type):
        """Sets the guest_os_type of this VmImportParams.


        :param guest_os_type: The guest_os_type of this VmImportParams.  # noqa: E501
        :type guest_os_type: VmGuestsOperationSystem
        """

        self._guest_os_type = guest_os_type

    @property
    def folder_id(self):
        """Gets the folder_id of this VmImportParams.  # noqa: E501


        :return: The folder_id of this VmImportParams.  # noqa: E501
        :rtype: str
        """
        return self._folder_id

    @folder_id.setter
    def folder_id(self, folder_id):
        """Sets the folder_id of this VmImportParams.


        :param folder_id: The folder_id of this VmImportParams.  # noqa: E501
        :type folder_id: str
        """

        self._folder_id = folder_id

    @property
    def description(self):
        """Gets the description of this VmImportParams.  # noqa: E501


        :return: The description of this VmImportParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this VmImportParams.


        :param description: The description of this VmImportParams.  # noqa: E501
        :type description: str
        """

        self._description = description

    @property
    def name(self):
        """Gets the name of this VmImportParams.  # noqa: E501


        :return: The name of this VmImportParams.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VmImportParams.


        :param name: The name of this VmImportParams.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def host_id(self):
        """Gets the host_id of this VmImportParams.  # noqa: E501


        :return: The host_id of this VmImportParams.  # noqa: E501
        :rtype: str
        """
        return self._host_id

    @host_id.setter
    def host_id(self, host_id):
        """Sets the host_id of this VmImportParams.


        :param host_id: The host_id of this VmImportParams.  # noqa: E501
        :type host_id: str
        """

        self._host_id = host_id

    @property
    def cluster_id(self):
        """Gets the cluster_id of this VmImportParams.  # noqa: E501


        :return: The cluster_id of this VmImportParams.  # noqa: E501
        :rtype: str
        """
        return self._cluster_id

    @cluster_id.setter
    def cluster_id(self, cluster_id):
        """Sets the cluster_id of this VmImportParams.


        :param cluster_id: The cluster_id of this VmImportParams.  # noqa: E501
        :type cluster_id: str
        """
        if self.local_vars_configuration.client_side_validation and cluster_id is None:  # noqa: E501
            raise ValueError("Invalid value for `cluster_id`, must not be `None`")  # noqa: E501

        self._cluster_id = cluster_id

    @property
    def upload_tasks(self):
        """Gets the upload_tasks of this VmImportParams.  # noqa: E501


        :return: The upload_tasks of this VmImportParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._upload_tasks

    @upload_tasks.setter
    def upload_tasks(self, upload_tasks):
        """Sets the upload_tasks of this VmImportParams.


        :param upload_tasks: The upload_tasks of this VmImportParams.  # noqa: E501
        :type upload_tasks: list[str]
        """
        if self.local_vars_configuration.client_side_validation and upload_tasks is None:  # noqa: E501
            raise ValueError("Invalid value for `upload_tasks`, must not be `None`")  # noqa: E501

        self._upload_tasks = upload_tasks

    @property
    def owner_id(self):
        """Gets the owner_id of this VmImportParams.  # noqa: E501


        :return: The owner_id of this VmImportParams.  # noqa: E501
        :rtype: str
        """
        return self._owner_id

    @owner_id.setter
    def owner_id(self, owner_id):
        """Sets the owner_id of this VmImportParams.


        :param owner_id: The owner_id of this VmImportParams.  # noqa: E501
        :type owner_id: str
        """

        self._owner_id = owner_id

    @property
    def parsed_ovf(self):
        """Gets the parsed_ovf of this VmImportParams.  # noqa: E501


        :return: The parsed_ovf of this VmImportParams.  # noqa: E501
        :rtype: ParsedOVF
        """
        return self._parsed_ovf

    @parsed_ovf.setter
    def parsed_ovf(self, parsed_ovf):
        """Sets the parsed_ovf of this VmImportParams.


        :param parsed_ovf: The parsed_ovf of this VmImportParams.  # noqa: E501
        :type parsed_ovf: ParsedOVF
        """
        if self.local_vars_configuration.client_side_validation and parsed_ovf is None:  # noqa: E501
            raise ValueError("Invalid value for `parsed_ovf`, must not be `None`")  # noqa: E501

        self._parsed_ovf = parsed_ovf

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VmImportParams):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, VmImportParams):
            return True

        return self.to_dict() != other.to_dict()
